'''
plasmac_axis.py
Copyright (C) 2018 2019  Phillip A Carter

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'''

''' set the window size, change pad_width and pad_height to suit your setup
    then uncomment the next 13 lines'''
#maxgeo=root_window.tk.call('wm','maxsize','.')
#if type(maxgeo) == tuple:
#    fullsize=str(maxgeo[0]),str(maxgeo[1])
#else:
#    fullsize=maxgeo.split(' ')[0],maxgeo.split(' ')[1]
#pad_width=60
#pad_height=60
#width=str(int(fullsize[0])-pad_width)
#height=str(int(fullsize[1])-pad_height)
#x=str(pad_width/2)
#y=str(pad_height/2)
#print '\nAxis window is', width, 'x', height, 'and starts at', x, 'x', y, '\n'
#root_window.tk.call('wm','geometry','.',width + 'x' + height + '+' + x + '+' + y)

# disable the 'do you want to close' dialog
root_window.tk.call('wm','protocol','.','WM_DELETE_WINDOW','destroy .')

# set the default font and the gcode font
font = inifile.find("PLASMAC","FONT") or 'sans 19'
fname, fsize = font.split()
root_window.tk.call('font','configure','TkDefaultFont','-family', fname, '-size', fsize)
root_window.tk.call('.pane.bottom.t.text','configure','-height','19','-font', font, '-foreground','blue')

# some names to save fingers
ftop = '.pane.top'
fmanual = ftop + '.tabs.fmanual'
faxes = fmanual + '.axes'
fjoints = fmanual + '.joints'
fjogf = fmanual + '.jogf'
ftorch = fmanual + '.torch'
foverride = fmanual + '.override'
fpausedmotion = fmanual + '.pausedmotion'
fmonitor = '.pane.bottom.t.common.monitor'
fbuttons = '.pane.bottom.t.common.buttons'
frun = '.plasmac.frun'
fconfig = '.plasmac.fconfig'
fmaterial = '.plasmac.frun.material'
fcutparms = '.plasmac.frun.cutparms'


# redo the text in tabs so they resize for the new default font
root_window.tk.call(ftop + '.tabs','itemconfigure','manual','-text',' Manual - F3 ')
root_window.tk.call(ftop + '.tabs','itemconfigure','mdi','-text',' MDI - F5 ')
root_window.tk.call(ftop + '.right','itemconfigure','preview','-text',' Preview ')
root_window.tk.call(ftop + '.right','itemconfigure','numbers','-text',' DRO ')

# hide some original widgets
root_window.tk.call('pack','forget','.toolbar.rule0')
root_window.tk.call('pack','forget','.toolbar.rule4')
root_window.tk.call('pack','forget','.toolbar.rule8')
root_window.tk.call('pack','forget','.toolbar.rule9')
root_window.tk.call('grid','forget',fmanual + '.axis')
root_window.tk.call('grid','forget',fmanual + '.jogf')
root_window.tk.call('grid','forget',fmanual + '.space2')
root_window.tk.call('grid','forget',fmanual + '.spindlel')
root_window.tk.call('grid','forget',fmanual + '.spindlef')
root_window.tk.call('grid','forget',fmanual + '.space2')
root_window.tk.call('grid','forget',fmanual + '.coolant')
root_window.tk.call('grid','forget',fmanual + '.mist')
root_window.tk.call('grid','forget',fmanual + '.flood')
root_window.tk.call('grid','forget',ftop + '.spinoverride')

# change layout for some scales
root_window.tk.call('pack','forget',ftop + '.jogspeed.l0')
root_window.tk.call('pack','forget',ftop + '.jogspeed.l')
root_window.tk.call('pack','forget',ftop + '.jogspeed.l1')
root_window.tk.call('pack','forget',ftop + '.jogspeed.s')
root_window.tk.call('pack','forget',ftop + '.maxvel.l0')
root_window.tk.call('pack','forget',ftop + '.maxvel.l')
root_window.tk.call('pack','forget',ftop + '.maxvel.l1')
root_window.tk.call('pack','forget',ftop + '.maxvel.s')
root_window.tk.call('pack',ftop + '.jogspeed.s','-side','right')
root_window.tk.call('pack',ftop + '.jogspeed.l1','-side','right')
root_window.tk.call('pack',ftop + '.jogspeed.l','-side','right')
root_window.tk.call('pack',ftop + '.jogspeed.l0','-side','left')
root_window.tk.call('pack',ftop + '.maxvel.s','-side','right')
root_window.tk.call('pack',ftop + '.maxvel.l1','-side','right')
root_window.tk.call('pack',ftop + '.maxvel.l','-side','right')
root_window.tk.call('pack',ftop + '.maxvel.l0','-side','left')

# modify the toolbar
root_window.tk.call('label','.toolbar.space1','-width','5')
root_window.tk.call('label','.toolbar.space2','-width','5')
root_window.tk.call('label','.toolbar.space3','-width','5')
root_window.tk.call('label','.toolbar.space4','-width','10')
root_window.tk.call('pack','.toolbar.space1','-after','.toolbar.machine_power','-side','left')
root_window.tk.call('pack','.toolbar.space2','-after','.toolbar.reload','-side','left')
root_window.tk.call('pack','.toolbar.space3','-after','.toolbar.program_stop','-side','left')
root_window.tk.call('pack','.toolbar.space4','-after','.toolbar.program_optpause','-side','left')

# set sizes for widgets
swidth = 5  # spinboxes width
lwidth = 11 # labels width
bwidth = 8  # buttons width
cwidth = int(fsize) * 2 #canvas width
cheight = int(fsize) * 2 #canvas height
ledwidth = cwidth - 2 #led width
ledheight = cheight - 2 #led height
ledx = cwidth-ledwidth # led x start
ledy = cheight-ledheight # led y start

# rework the axis/joints frame
root_window.tk.call('destroy',faxes)
root_window.tk.call('labelframe',faxes,'-text','Axis:','-relief','ridge')
root_window.tk.call('destroy',fjoints)
root_window.tk.call('labelframe',fjoints,'-text','Joint:','-relief','ridge')
# make axis radiobuttons
for letter in 'xyzabcuvw':
    root_window.tk.call('radiobutton',faxes + '.axis' + letter,\
                        '-anchor','w',\
                        '-padx','0',\
                        '-value',letter,\
                        '-variable','ja_rbutton',\
                        '-width','2',\
                        '-text',letter.upper(),\
                        '-command','ja_button_activated',\
                        )
# populate the axes frame
count = 0
letters = 'xyzabcuvw'
first_axis = ''
for row in range(0,2):
    for column in range(0,5):
        if letters[count] in trajcoordinates:
            if first_axis == '':
                first_axis = letters[count]
            root_window.tk.call('grid',faxes + '.axis' + letters[count],'-row',row,'-column',column,'-padx','4')
        count += 1
        if count == 9: break
# make joints radiobuttons
for number in range(0,linuxcnc.MAX_JOINTS):
    root_window.tk.call('radiobutton',fjoints + '.joint' + str(number),\
                        '-anchor','w',\
                        '-padx','0',\
                        '-value',number,\
                        '-variable','ja_rbutton',\
                        '-width','2',\
                        '-text',number,\
                        '-command','ja_button_activated',\
                        )
# populate joints frame
count = 0
for row in range(0,2):
    for column in range(0,5):
        if count == jointcount: break
        root_window.tk.call('grid',fjoints + '.joint' + str(count),'-row',row,'-column',column,'-padx','4')
        count += 1

# rework the jogf frame
root_window.tk.call('destroy',fjogf)
root_window.tk.call('labelframe',fjogf,'-relief','flat','-bd','0')
root_window.tk.call('labelframe',fjogf + '.jog','-text','Jog','-relief','ridge')
root_window.tk.call('button',fjogf + '.jog.jogminus','-command','if ![is_continuous] {jog_minus 1}','-height','1','-text','-')
root_window.tk.call('bind',fjogf + '.jog.jogminus','<Button-1>','if [is_continuous] {jog_minus}')
root_window.tk.call('bind',fjogf + '.jog.jogminus','<ButtonRelease-1>','if [is_continuous] {jog_stop}')
root_window.tk.call('button',fjogf + '.jog.jogplus','-command','if ![is_continuous] {jog_plus 1}','-height','1','-text','+')
root_window.tk.call('bind',fjogf + '.jog.jogplus','<Button-1>','if [is_continuous] {jog_plus}')
root_window.tk.call('bind',fjogf + '.jog.jogplus','<ButtonRelease-1>','if [is_continuous] {jog_stop}')
root_window.tk.call('combobox',fjogf + '.jog.jogincr','-editable','0','-textvariable','jogincrement','-value','Continuous','-width','10')
root_window.tk.call(fjogf + '.jog.jogincr','list','insert','end','Continuous',0.1000,0.0100,0.0010,0.0001)
root_window.tk.call('labelframe',fjogf + '.zerohome','-text','Zero','-relief','ridge')
root_window.tk.call('button',fjogf + '.zerohome.home','-command','home_joint','-height','1')
root_window.tk.call('setup_widget_accel',fjogf + '.zerohome.home','Home Axis')
root_window.tk.call('button',fjogf + '.zerohome.zero','-command','touch_off_system','-height','1')
root_window.tk.call('setup_widget_accel',fjogf + '.zerohome.zero','Touch Off')
# unused, just for tcl hierarchy
root_window.tk.call('button',fjogf + '.zerohome.tooltouch')
root_window.tk.call('checkbutton',fjogf + '.override')
# populate the jog frame
root_window.tk.call('grid',fjogf + '.jog.jogminus','-row','0','-column','0','-padx','0 3','-sticky','nsew')
root_window.tk.call('grid',fjogf + '.jog.jogplus','-row','0','-column','1','-padx','3 3','-sticky','nsew')
root_window.tk.call('grid',fjogf + '.jog.jogincr','-row','0','-column','2','-padx','3 0','-sticky','nsew')
root_window.tk.call('grid',fjogf + '.jog','-row','0','-column','0','-sticky','ew')
root_window.tk.call('grid',fjogf + '.zerohome.home','-row','0','-column','0','-padx','0 3','-sticky','ew')
root_window.tk.call('grid',fjogf + '.zerohome.zero','-row','0','-column','1','-padx','3 0','-sticky','ew')
root_window.tk.call('grid',fjogf + '.zerohome','-row','1','-column','0','-pady','4 0','-sticky','ew')
root_window.tk.call('grid',fjogf,'-column','0','-row','1','-padx','4','-pady','4 0','-sticky','ew')
root_window.tk.call('grid','columnconfigure',fmanual,'0','-weight','1')
root_window.tk.call('grid','columnconfigure',fjogf,'0','-weight','1')
root_window.tk.call('grid','columnconfigure',fjogf + '.jog','0 1 2','-weight','1')
root_window.tk.call('grid','columnconfigure',fjogf + '.zerohome','0 1','-weight','1')
if homing_order_defined:
    widgets.homebutton.configure(text=_('Home All'), command='home_all_joints')
    root_window.tk.call('DynamicHelp::add', widgets.homebutton,'-text', _('Home all %ss [Ctrl-Home]') % ja_name)

# torch frame
root_window.tk.call('labelframe',ftorch,'-text','Torch:','-relief','ridge')
root_window.tk.call('Button', ftorch + '.torch-button','-text','PULSE','-takefocus','0','-width','3')
root_window.tk.call('bind',ftorch + '.torch-button','<Button-1>','torch_pulse 1')
root_window.tk.call('bind',ftorch + '.torch-button','<ButtonRelease-1>','torch_pulse 0')
root_window.tk.call('append','manualgroup',' ' + ftorch + '.torch-button')
root_window.tk.call('scale', ftorch + '.torch-pulse-time','-orient','horizontal','-variable','torchPulse','-showvalue','0')
root_window.tk.call('label', ftorch + '.torch-time','-textvariable','torchPulse','-width','3','-anchor','e')
root_window.tk.call('label', ftorch + '.torch-label','-text','Sec','-anchor','e')
root_window.tk.call('pack', ftorch + '.torch-button','-side','left','-pady','2')
root_window.tk.call('pack', ftorch + '.torch-pulse-time','-side','left','-fill','x','-expand','1')
root_window.tk.call('pack', ftorch + '.torch-label','-side','right')
root_window.tk.call('pack', ftorch + '.torch-time','-side','right')
root_window.tk.call('grid',ftorch,'-column','0','-row','2','-columnspan','1','-padx','4','-pady','4 0','-sticky','ew')

# override frame
root_window.tk.call('labelframe',foverride,'-text','Height Override:','-relief','ridge')
root_window.tk.call('scale',foverride + '.height-override','-orient','horizontal')
root_window.tk.call('pack',foverride + '.height-override','-fill','x','-expand','1')
root_window.tk.call('grid',foverride,'-column','0','-row','3','-columnspan','1','-padx','4','-pady','4 0','-sticky','ew')

# paused motion frame
root_window.tk.call('labelframe',fpausedmotion,'-text','Paused Motion Speed:','-relief','ridge')
root_window.tk.call('Button',fpausedmotion + '.reverse','-text','Rev','-takefocus','0','-width','3')
root_window.tk.call('bind',fpausedmotion + '.reverse','<Button-1>','paused_motion -1')
root_window.tk.call('bind',fpausedmotion + '.reverse','<ButtonRelease-1>','paused_motion 0')
root_window.tk.call('scale',fpausedmotion + '.paused-motion-speed','-orient','horizontal')
root_window.tk.call('Button',fpausedmotion + '.forward','-text','Fwd','-takefocus','0','-width','3')
root_window.tk.call('bind',fpausedmotion + '.forward','<Button-1>','paused_motion 1')
root_window.tk.call('bind',fpausedmotion + '.forward','<ButtonRelease-1>','paused_motion 0')
root_window.tk.call('pack',fpausedmotion + '.reverse','-side','left','-fill','y')
root_window.tk.call('pack',fpausedmotion + '.paused-motion-speed','-side','left','-fill','x','-expand','1')
root_window.tk.call('pack',fpausedmotion + '.forward','-side','right','-fill','y')
root_window.tk.call('grid',fpausedmotion,'-column','0','-row','4','-columnspan','1','-padx','4','-pady','4 0','-sticky','ew')

# bottom pane - hide until modified
root_window.tk.call('pack','forget','.pane.bottom.t.text')
root_window.tk.call('pack','forget','.pane.bottom.t.sb')

# common frame
common = '.pane.bottom.t.common'
root_window.tk.call('labelframe',common,'-text','','-relief','raised')

# monitor frame
root_window.tk.call('labelframe',fmonitor,'-text','','-relief','flat')
arcfont = fname + ' ' + str(int(fsize) + 2) + ' bold'
root_window.tk.call('label',fmonitor + '.arc-voltage','-anchor','e','-width',swidth,'-fg','blue','-font',arcfont)
root_window.tk.call('label',fmonitor + '.aVlab','-text','Arc Voltage')
root_window.tk.call('canvas',fmonitor + '.led-float','-width',cwidth,'-height',cheight)
root_window.tk.call(fmonitor + '.led-float','create','oval',ledx,ledy,ledwidth,ledheight,'-fill','red','-disabledfill','grey')
root_window.tk.call('label',fmonitor + '.lFlab','-text','Float Switch')
root_window.tk.call('canvas',fmonitor + '.led-torch','-width',cwidth,'-height',cheight)
root_window.tk.call(fmonitor + '.led-torch','create','oval',ledx,ledy,ledwidth,ledheight,'-fill','orange','-disabledfill','grey')
root_window.tk.call('label',fmonitor + '.lTlab','-text','Torch On')
root_window.tk.call('canvas',fmonitor + '.led-breakaway','-width',cwidth,'-height',cheight)
root_window.tk.call(fmonitor + '.led-breakaway','create','oval',ledx,ledy,ledwidth,ledheight,'-fill','red','-disabledfill','grey')
root_window.tk.call('label',fmonitor + '.lBlab','-text','Breakaway')
root_window.tk.call('canvas',fmonitor + '.led-arc-ok','-width',cwidth,'-height',cheight)
root_window.tk.call(fmonitor + '.led-arc-ok','create','oval',ledx,ledy,ledwidth,ledheight,'-fill','lightgreen','-disabledfill','grey')
root_window.tk.call('label',fmonitor + '.lAOlab','-text','Ark OK')
root_window.tk.call('canvas',fmonitor + '.led-safe-height','-width',cwidth,'-height',cheight)
root_window.tk.call(fmonitor + '.led-safe-height','create','oval',ledx,ledy,ledwidth,ledheight,'-fill','red','-disabledfill','grey')
root_window.tk.call('label',fmonitor + '.lSHlab','-text','Safe Limited')
root_window.tk.call('grid',fmonitor + '.arc-voltage','-row','0','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.aVlab','-row','0','-column','1',)
root_window.tk.call('grid',fmonitor + '.led-float','-row','1','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.lFlab','-row','1','-column','1')
root_window.tk.call('grid',fmonitor + '.led-torch','-row','2','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.lTlab','-row','2','-column','1')
root_window.tk.call('grid',fmonitor + '.led-breakaway','-row','3','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.lBlab','-row','3','-column','1')
root_window.tk.call('grid',fmonitor + '.led-arc-ok','-row','4','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.lAOlab','-row','4','-column','1')
root_window.tk.call('grid',fmonitor + '.led-safe-height','-row','5','-column','0','-sticky','e')
root_window.tk.call('grid',fmonitor + '.lSHlab','-row','5','-column','1')
root_window.tk.call('grid','rowconfigure',fmonitor,'0 1 2 3 4 5','-pad','4')

# buttons frame
root_window.tk.call('labelframe',fbuttons,'-relief','flat')
root_window.tk.call('button',fbuttons + '.xtohome','-text','X to Home','-command','x_to_home','-width',bwidth)
root_window.tk.call('button',fbuttons + '.ytohome','-text','Y to Home','-command','y_to_home','-width',bwidth)
root_window.tk.call('button',fbuttons + '.ztohome','-text','Z to Home','-command','z_to_home','-width',bwidth)
root_window.tk.call('button',fbuttons + '.dryRun','-text','Dry Run','-width',bwidth)
root_window.tk.call('bind',fbuttons + '.dryRun','<Button-1>','dry_run 1')
root_window.tk.call('bind',fbuttons + '.dryRun','<ButtonRelease-1>','dry_run 0')
root_window.tk.call('grid',fbuttons + '.xtohome','-row','0','-column','0')
root_window.tk.call('grid',fbuttons + '.ytohome','-row','1','-column','0')
root_window.tk.call('grid',fbuttons + '.ztohome','-row','2','-column','0')
root_window.tk.call('grid',fbuttons + '.dryRun','-row','3','-column','0')
root_window.tk.call('grid','columnconfigure',fbuttons,0,'-weight','1')

# populate bottom frame
root_window.tk.call('pack',fmonitor,'-fill','y','-side','left')
root_window.tk.call('pack',fbuttons,'-fill','y','-side','left')
root_window.tk.call('.pane.bottom.t','configure','-relief','flat')
root_window.tk.call('.pane.bottom.t.text','configure','-borderwidth','2','-relief','sunken')
root_window.tk.call('pack',common,'-fill','y','-side','left')
root_window.tk.call('pack','.pane.bottom.t.text','-fill','both','-expand','1','-side','left','-padx','4','-pady','0')
root_window.tk.call('pack','.pane.bottom.t.sb','-fill','y','-side','left')

# new notebook for plasmac stuff
root_window.tk.call('NoteBook','.plasmac','-borderwidth','2','-arcradius','3')
root_window.tk.call('.plasmac','insert','end','run','-text','Run')
root_window.tk.call('.plasmac','insert','end','config','-text','Configure')

# frames for run tab
root_window.tk.call('labelframe',fmaterial,'-text','Material','-relief','ridge')
root_window.tk.call('labelframe',fcutparms,'-text','Cut Parameters','-relief','ridge')
root_window.tk.call('labelframe',fthc,'-text','THC','-relief','ridge')
root_window.tk.call('labelframe',flocks,'-text','Locks','-relief','ridge')

# frames for config tab
root_window.tk.call('labelframe',fmotion,'-text','Motion','-relief','ridge')
root_window.tk.call('labelframe',farc,'-text','Arc','-relief','ridge')
root_window.tk.call('labelframe',foffsets,'-text','Offsets','-relief','ridge')
root_window.tk.call('labelframe',fsettings,'-text','Settings','-relief','ridge')

# material frame
root_window.tk.call('ComboBox',fmaterial + '.materials','-modifycmd','material_changed')
root_window.tk.call('DynamicHelp::add',fmaterial + '.materials','-text','select material from materials file')
root_window.tk.call('pack',fmaterial + '.materials','-fill','x')


# settings frame
root_window.tk.call('button',fsettings + '.save','-text','Save','-command','save_config','-width',bwidth)
root_window.tk.call('button',fsettings + '.reload','-text','Reload','-width',bwidth,'-command','reload_config')
root_window.tk.call('grid',fsettings + '.save','-row','0','-column','0')
root_window.tk.call('grid',fsettings + '.reload','-row','0','-column','1')
root_window.tk.call('grid','columnconfigure',fsettings,'0 1','-weight','1','-pad','2')

# populate run tab
root_window.tk.call('pack',fmaterial,'-fill','x')
root_window.tk.call('pack',fcutparms,'-fill','x')
root_window.tk.call('pack',fthc,'-fill','x')
root_window.tk.call('pack',flocks,'-fill','x')

# populate config tab
root_window.tk.call('pack',fmotion,'-fill','x','-expand','0')
root_window.tk.call('pack',farc,'-fill','x','-expand','0')
root_window.tk.call('pack',foffsets,'-fill','x','-expand','0')
root_window.tk.call('pack',fsettings,'-fill','x','-expand','0')

# move original pane to right
root_window.tk.call('grid','.pane','-column','1','-row','1','-sticky','nsew','-rowspan','2')

# place new notebook left of original pane
root_window.tk.call('.plasmac','raise','run')
root_window.tk.call('grid','.plasmac','-column','0','-row','1','-sticky','nsew','-rowspan','2')
root_window.tk.call('grid','columnconfigure','.','0','-weight','0')
root_window.tk.call('grid','columnconfigure','.','1','-weight','1')

# some new commands for TCL
def material_changed():
    if not materialsUpdate:
        newmaterial = root_window.tk.call(fmaterial + '.materials','getvalue')
        root_window.tk.call(fcutparms + '.pierce-height','set',materialsList[newmaterial][1])
        root_window.tk.call(fcutparms + '.pierce-delay','set',materialsList[newmaterial][2])
        root_window.tk.call(fcutparms + '.puddle-jump-height','set',materialsList[newmaterial][3])
        root_window.tk.call(fcutparms + '.puddle-jump-delay','set',materialsList[newmaterial][4])
        root_window.tk.call(fcutparms + '.cut-height','set',materialsList[newmaterial][5])
        root_window.tk.call(fcutparms + '.cut-feed-rate','set',materialsList[newmaterial][6])
        root_window.tk.call(fcutparms + '.cut-amps','set',materialsList[newmaterial][7])
        root_window.tk.call(fcutparms + '.cut-volts','set',materialsList[newmaterial][8])

def save_config():
    try:
        with open(configFile, 'w') as f_out:
            f_out.write('#plasmac configuration file, format is:\n#name = value\n\n')
            for key in sorted(configDict.iterkeys()):
                for widget in wCheckbuttons + wSpinboxes + wScalesConfig:
                    if widget.endswith(key):
                        if widget in wCheckbuttons:
                            value = root_window.tk.call('set',key)
                            f_out.write(key + ' = ' + str(value) + '\n')
                            break
                        elif widget in wSpinboxes + wScalesConfig:
                            value = root_window.tk.call(widget,'get')
                            f_out.write(key + ' = ' + str(value) + '\n')
                            break
    except:
        print '*** error opening', configFile
#    except Exception:
#        traceback.print_exc()
    finally:
        f_out.close()

def reload_config():
    materialsUpdate = True
    load_settings()
    global materialsList
    materialsList = []
    root_window.tk.call(fmaterial + '.materials','configure','-values','')
    get_materials()
    materialsUpdate = False

def x_to_home():
    goto_home('X')

def y_to_home():
    goto_home('Y')

def z_to_home():
    goto_home('Z')


def goto_home(axis):
    if hal.get_value('halui.program.is-idle'):
        home = inifile.find('JOINT_' + str(inifile.find('TRAJ', 'COORDINATES').upper().index(axis)), 'HOME')
        mode = hal.get_value('halui.mode.is-mdi')
        if not mode:
            c.mode(linuxcnc.MODE_MDI)
        c.mdi('G53 G0 ' + axis + home)

def joint_mode_switch(a,b,c):
    if vars.motion_mode.get() == linuxcnc.TRAJ_MODE_FREE and s.kinematics_type != linuxcnc.KINEMATICS_IDENTITY:
        root_window.tk.call('grid','forget',fmanual + '.axes')
        root_window.tk.call('grid',fmanual + '.joints','-column','0','-row','0','-padx','4','-pady','0','-sticky','ew')
        widget = getattr(widgets, "joint_%d" % 0)
        widget.focus()
        vars.ja_rbutton.set(0)
    else:
        root_window.tk.call('grid','forget',fmanual + '.joints')
        root_window.tk.call('grid',fmanual + '.axes','-column','0','-row','0','-padx','4','-pady','0','-sticky','ew')
        widget = getattr(widgets, "axis_%s" % first_axis)
        widget.focus()
        vars.ja_rbutton.set(first_axis)



# add the commands to TclCommands
TclCommands.material_changed = material_changed
TclCommands.save_config = save_config
TclCommands.reload_config = reload_config
TclCommands.x_to_home = x_to_home
TclCommands.y_to_home = y_to_home
TclCommands.z_to_home = z_to_home
TclCommands.joint_mode_switch = joint_mode_switch
commands = TclCommands(root_window)

# some python functions

# original in axis.py line 3000
def user_live_update():
    for widget in wSpinboxes + wScalesHal:
        tmp, item = widget.rsplit('.',1)
        if item != 'cut-amps':
            value = float(root_window.tk.call(widget,'get'))
            if value != widgetValues[widget]:
                widgetValues[widget] = value
                if item == 'arc-max-starts':
                    hal.set_p('plasmac.%s' % (item),'%d' % (value))
                else:
                    hal.set_p('plasmac.%s' % (item),'%f' % (value))
                if item == 'setup-feed-rate': #limit max probe feed rate to setup feed rate
                    root_window.tk.call(fmotion + '.probe-feed-rate','configure','-to',value)
    for widget in wCheckbuttons:
        tmp, item = widget.rsplit('.',1)
        value = int(root_window.tk.call('set',item))
        if value != widgetValues[widget]:
            widgetValues[widget] = value
            hal.set_p('plasmac.%s' % (item),'%d' % (value))
    for widget in wLeds:
        tmp, item = widget.rsplit('.',1)
        if pcomp[item] != widgetValues[widget]:
            widgetValues[widget] = pcomp[item]
            if pcomp[item] == 1:
                root_window.tk.call(widget,'configure','-state','normal')
            else:
                root_window.tk.call(widget,'configure','-state','disabled')
    root_window.tk.call(fmonitor + '.arc-voltage','configure','-text','%0.1f' % (pcomp['arc-voltage']))
    if all_homed() and hal.get_value('halui.program.is-idle'):
        root_window.tk.call(fbuttons + '.xtohome','configure','-state','normal')
        root_window.tk.call(fbuttons + '.ytohome','configure','-state','normal')
        root_window.tk.call(fbuttons + '.ztohome','configure','-state','normal')
        root_window.tk.call(fbuttons + '.dryRun','configure','-state','normal')
    else:
        root_window.tk.call(fbuttons + '.xtohome','configure','-state','disabled')
        root_window.tk.call(fbuttons + '.ytohome','configure','-state','disabled')
        root_window.tk.call(fbuttons + '.ztohome','configure','-state','disabled')
        root_window.tk.call(fbuttons + '.dryRun','configure','-state','disabled')
    if hal.get_value('halui.machine.is-on') and hal.get_value('halui.program.is-idle'):
        root_window.tk.call(ftorch + '.torch-button','configure','-state','normal')
    else:
        root_window.tk.call(ftorch + '.torch-button','configure','-state','disabled')
    if hal.get_value('halui.program.is-paused') or hal.get_value('plasmac.paused-motion-speed'):
        root_window.tk.call(fpausedmotion + '.reverse','configure','-state','normal')
        root_window.tk.call(fpausedmotion + '.forward','configure','-state','normal')
    else:
        root_window.tk.call(fpausedmotion + '.reverse','configure','-state','disabled')
        root_window.tk.call(fpausedmotion + '.forward','configure','-state','disabled')
    if hal.get_value('plasmac_panel.config-disable'):
        root_window.tk.call('.plasmac','itemconfigure','config','-state','disabled')
    else:
        root_window.tk.call('.plasmac','itemconfigure','config','-state','normal')

def configure_widgets():
    root_window.tk.call(ftorch + '.torch-pulse-time','configure','-from','0','-to','3','-resolution','0.1')
    root_window.tk.call(foverride + '.height-override','configure','-from','-10','-to','10','-resolution','0.1') #0
    root_window.tk.call(fpausedmotion + '.paused-motion-speed','configure','-from','.01','-to','1','-resolution','0.01') #0
    root_window.tk.call(fcutparms + '.pierce-delay','configure','-from','0','-to','10','-increment','0.1','-format','%0.1f') #0.1
    root_window.tk.call(fcutparms + '.puddle-jump-height','configure','-from','0','-to','200','-increment','1','-format','%0.0f') #0
    root_window.tk.call(fcutparms + '.puddle-jump-delay','configure','-from','0','-to','9','-increment','0.01','-format','%0.2f') #0
    root_window.tk.call(fcutparms + '.cut-amps','configure','-from','0','-to','999','-increment','1','-format','%0.0f') #45
    root_window.tk.call(fcutparms + '.cut-volts','configure','-from','50','-to','300','-increment','0.1','-format','%0.1f') #122
    root_window.tk.call(fthc + '.use-auto-volts','select')
    root_window.tk.call(fthc + '.thc-enable','select')
    root_window.tk.call(fthc + '.thc-threshold','configure','-from','0.05','-to','9','-increment','0.01','-format','%0.2f') #1
    root_window.tk.call(fcornerlock + '.cornerlock-enable','select')
    root_window.tk.call(fcornerlock + '.cornerlock-threshold','configure','-from','1','-to','99','-increment','1','-format','%0.0f') #90
    root_window.tk.call(fkerflock + '.kerfcross-enable','select')
    root_window.tk.call(fkerflock + '.kerfcross-threshold','configure','-from','1','-to','10','-increment','0.1','-format','%0.1f') #3
    root_window.tk.call(farc + '.torch-off-delay','configure','-from','0','-to','9','-increment','0.1','-format','%0.1f') #0
    root_window.tk.call(farc + '.arc-fail-delay','configure','-from','0','-to','60','-increment','0.1','-format','%0.1f') #1
    root_window.tk.call(farc + '.arc-ok-low','configure','-from','0','-to','200','-increment','0.5','-format','%0.1f') #0
    root_window.tk.call(farc + '.arc-ok-high','configure','-from','50','-to','200','-increment','0.5','-format','%0.1f') #50
    root_window.tk.call(farc + '.arc-max-starts','configure','-from','1','-to','9','-increment','1','-format','%0.0f') #3
    root_window.tk.call(farc + '.restart-delay','configure','-from','1','-to','60','-increment','1','-format','%0.0f') #1
    root_window.tk.call(farc + '.arc-voltage-offset','configure','-from','-100','-to','100','-increment','0.1','-format','%0.1f') #0
    root_window.tk.call(farc + '.arc-voltage-scale','configure','-from','0.01','-to','99','-increment','0.01','-format','%0.2f') #1
    root_window.tk.call(foffsets + '.maxspeed','configure','-text',str(int(thcFeedRate)))
    root_window.tk.call(foffsets + '.pid-i-gain','configure','-from','0','-to','1000','-increment','1','-format','%0.0f') #0
    root_window.tk.call(foffsets + '.pid-d-gain','configure','-from','0','-to','1000','-increment','1','-format','%0.0f') #0
    if inifile.find('TRAJ','LINEAR_UNITS').lower() == 'mm':
        root_window.tk.call(fcutparms + '.cut-feed-rate','configure','-from','50','-to','9999','-increment','1','-format','%0.0f') #4000
        root_window.tk.call(fcutparms + '.cut-height','configure','-from','0','-to','25.4','-increment','0.1','-format','%0.1f') #1
        root_window.tk.call(fcutparms + '.pierce-height','configure','-from','0','-to','25.4','-increment','0.1','-format','%0.1f') #4
        root_window.tk.call(fmotion + '.float-switch-travel','configure','-from','0','-to','20','-increment','0.01','-format','%0.2f') #1.5
        root_window.tk.call(fmotion + '.probe-feed-rate','configure','-from','1','-to',thcFeedRate,'-increment','1','-format','%0.0f') #300
        root_window.tk.call(fmotion + '.safe-height','configure','-from','1','-to','99','-increment','1','-format','%0.0f') #20
        root_window.tk.call(fmotion + '.skip-ihs-distance','configure','-from','0','-to','999','-increment','1','-format','%0.0f') #0
        root_window.tk.call(foffsets + '.setup-feed-rate','configure','-from','1','-to',thcFeedRate,'-increment','1','-format','%0.0f') #int(thcFeedRate * 0.8)
    elif inifile.find('TRAJ','LINEAR_UNITS').lower() == 'inch':
        root_window.tk.call(fcutparms + '.cut-feed-rate','configure','-from','2','-to','400','-increment','0.1','-format','%0.1f') #160
        root_window.tk.call(fcutparms + '.cut-height','configure','-from','0','-to','1','-increment','0.01','-format','%0.2f') #0.04
        root_window.tk.call(fcutparms + '.pierce-height','configure','-from','0','-to','1','-increment','0.01','-format','%0.2f') #0.16
        root_window.tk.call(fmotion + '.float-switch-travel','configure','-from','0','-to','0.75','-increment','0.001','-format','%0.3f') #0.06
        root_window.tk.call(fmotion + '.probe-feed-rate','configure','-from','0.1','-to',thcFeedRate,'-increment','0.1','-format','%0.1f') #12
        root_window.tk.call(fmotion + '.safe-height','configure','-from','0.04','-to','4','-increment','0.01','-format','%0.2f') #0.75
        root_window.tk.call(fmotion + '.skip-ihs-distance','configure','-from','0','-to','99','-increment','0.1','-format','%0.1f') #0
        root_window.tk.call(foffsets + '.setup-feed-rate','configure','-from','0.1','-to',thcFeedRate,'-increment','0.1','-format','%0.1f') #int(thcFeedRate * 0.8)
    else:
        print '*** incorrect [TRAJ]LINEAR_UNITS in ini file'

def load_settings():
    for widget in wCheckbuttons + wSpinboxes + wScalesConfig:
        tmp, item = widget.rsplit('.',1)
        if item != 'height-override':
            configDict[item] = '0'
    convertFile = False
    if os.path.exists(configFile):
        try:
            tmpDict = {}
            with open(configFile, 'r') as f_in:
                for line in f_in:
                    if not line.startswith('#') and not line.startswith('[') and not line.startswith('\n'):
                        if 'version' in line or 'signature' in line:
                            convertFile = True
                        else:
                            (key, value) = line.strip().replace(" ", "").split('=')
                            if value == 'True':value = True
                            if value == 'False':value = False
                            if key in configDict:
                                configDict[key] = value
                                tmpDict[key] = value
        except:
            print '*** plasmac configuration file,', configFile, 'is invalid ***'
        finally:
            f_in.close()
        for widget in wCheckbuttons + wSpinboxes + wScalesConfig:
            tmp, item = widget.rsplit('.',1)
            if widget in wCheckbuttons:
                if item in tmpDict:
                    if configDict.get(item) == '1':
                        root_window.tk.call(widget,'select')
                        hal.set_p('plasmac.%s' % (item),'1')
                    else:
                        root_window.tk.call(widget,'deselect')
                        hal.set_p('plasmac.%s' % (item),'0')
                else:
                    root_window.tk.call(widget,'deselect')
                    hal.set_p('plasmac.%s' % (item),'0')
                    print '***', item, 'missing from', configFile
            elif widget in wSpinboxes + wScalesConfig:
                if item in tmpDict:
                    if item == 'setup-feed-rate' and float(configDict.get(item)) > thcFeedRate:
                        configDict[item] = thcFeedRate
                    root_window.tk.call(widget,'set',configDict.get(item))
                    if item == 'arc-max-starts':
                        hal.set_p('plasmac.%s' % (item),'%d' % (float(configDict.get(item))))
                    elif item != 'cut-amps' and item != 'paused-motion-speed':
                        hal.set_p('plasmac.%s' % (item),'%f' % (float(configDict.get(item))))
                else:
                    root_window.tk.call(widget,'set','0')
                    print '***', item, 'missing from', configFile
        if convertFile:
            print '*** converting', configFile, 'to new format'
            save_config()
    else:
        save_config()
        print '*** creating new plasmac configuration file,', configFile

def check_materials_file():
    version = '[VERSION 1]'
    header ='\
#plasmac configuration file\
\n#the next line is required for version checking\
\n' + version + '\n\
\n#example only, may be deleted\
\n#[MILD STEEL 1thick]\
\n#PIERCE_HEIGHT      = \
\n#PIERCE_DELAY       = \
\n#PUDDLE_JUMP_HEIGHT = (optional, set to 0 or delete if not required)\
\n#PUDDLE_JUMP_DELAY  = (optional, set to 0 or delete if not required)\
\n#CUT_HEIGHT         = \
\n#CUT_SPEED          = \
\n#CUT_AMPS           = (optional, only used for operator information)\
\n#CUT_VOLTS          = (modes 0 & 1 only, if not using auto voltage sampling)\
\n'
    tempMaterialsList = []
    if os.path.exists(materialsFile):
        if not version in open(materialsFile).read():
            print '*** upgrading material file...'
            with open(materialsFile, 'r') as f_in:
                for line in f_in:
                    if not line.strip().startswith('#') and len(line.strip()):
                        name, p_height, p_delay, pj_height, pj_delay, c_height, c_speed, c_amps, c_volts = line.split(',')
                        name = name.strip()
                        tempMaterialsList.append([name, p_height, p_delay, pj_height, pj_delay, c_height, c_speed, c_amps, c_volts])
            with open(materialsFile, 'w') as f_out:
                f_out.write(header)
                for material in tempMaterialsList:
                    f_out.write('\
\n[' + material[0] + ']\
\nPIERCE_HEIGHT      = ' + material[1] + '\
\nPIERCE_DELAY       = ' + material[2] + '\
\nPUDDLE_JUMP_HEIGHT = ' + material[3] + '\
\nPUDDLE_JUMP_DELAY  = ' + material[4] + '\
\nCUT_HEIGHT         = ' + material[5] + '\
\nCUT_SPEED          = ' + material[6] + '\
\nCUT_AMPS           = ' + material[7] + '\
\nCUT_VOLTS          = ' + material[8] + '\
')
    else:
        with open(materialsFile, 'w') as f_out:
            f_out.write(header)
        print '*** new material file,', materialsFile, 'created'

def get_materials():
    name = 'Default'
    p_height = root_window.tk.call(fcutparms + '.pierce-height','get')
    p_delay = root_window.tk.call(fcutparms + '.pierce-delay','get')
    pj_height = root_window.tk.call(fcutparms + '.puddle-jump-height','get')
    pj_delay = root_window.tk.call(fcutparms + '.puddle-jump-delay','get')
    c_height = root_window.tk.call(fcutparms + '.cut-height','get')
    c_speed = root_window.call(fcutparms + '.cut-feed-rate','get')
    c_amps = root_window.tk.call(fcutparms + '.cut-amps','get')
    c_volts = root_window.tk.call(fcutparms + '.cut-volts','get')
    try:
        with open(materialsFile, 'r') as f_in:
            for line in f_in:
                if not line.startswith('#'):
                    if line.startswith('[') and line.strip().endswith(']') and not 'VERSION' in line:
                        materialsList.append([name, p_height, p_delay, pj_height, pj_delay, c_height, c_speed, c_amps, c_volts])
                        root_window.tk.call(fmaterial + '.materials','insert','end',name)
                        name = line.strip().lstrip('[').rstrip(']')
                        p_height = p_delay = pj_height = pj_delay = c_height = c_speed = c_amps = c_volts = 0
                    elif line.startswith('PIERCE_HEIGHT'):
                        p_height = float(line.split('=')[1].strip())
                    elif line.startswith('PIERCE_DELAY'):
                        p_delay = float(line.split('=')[1].strip())
                    elif line.startswith('PUDDLE_JUMP_HEIGHT'):
                        pj_height = float(line.split('=')[1].strip())
                    elif line.startswith('PUDDLE_JUMP_DELAY'):
                        pj_delay = float(line.split('=')[1].strip())
                    elif line.startswith('CUT_HEIGHT'):
                        c_height = float(line.split('=')[1].strip())
                    elif line.startswith('CUT_SPEED'):
                        c_speed = float(line.split('=')[1].strip())
                    elif line.startswith('CUT_AMPS'):
                        c_amps = float(line.split('=')[1].strip())
                    elif line.startswith('CUT_VOLTS'):
                        c_volts = float(line.split('=')[1].strip())
            materialsList.append([name, p_height, p_delay, pj_height, pj_delay, c_height, c_speed, c_amps, c_volts])
            root_window.tk.call(fmaterial + '.materials','insert','end',name)
        root_window.tk.call(fmaterial + '.materials','setvalue','first')
    except:
        print '*** materials file,', materialsFile, 'is invalid'
    finally:
        f_in.close()

# setup

configFile = inifile.find('EMC','MACHINE').lower() + '.cfg'
materialsFile = inifile.find('EMC','MACHINE').lower() + '.mat'
materialsList = []
configDict = {}

